.Dd June 15, 2017
.Dt OOOK-WITH-LVM2-SNAPSHOT 1
.Sh NAME
.Nm oook-with-lvm2-snapshot
.Nd Back up a snapshot logical volume to Oook
.Sh SYNOPSIS
.Nm
.Ar command argument ...
.Ar filesystem
.Sh WARNING
.Nm
is newly-written and under-tested.  It is likely to contain serious
bugs and is not suitable for production use.
.Sh DESCRIPTION
.Nm
creates an LVM2 snapshot of
.Ar filesystem ,
mounts it, and uses
.Ic oook- Ns Ar command
to back it up.
.Pp
In more detail,
.Ar filesystem
must name either a device file representing an LVM2 logical volume or the
mount point of a filesystem mounted from such a volume.
.Nm
creates a snapshot of that volume, and then if the original logical
volume was mounted as a filesystem it mounts the snapshot read-only in
a new location.
The name of the new snapshot volume is derived deterministically from
the name of the original logical volume.
The name of the mount point for the snapshot is similarly derived
deterministically from the mount point of the original logical volume.
.Pp
Having created and mounted the snapshot,
.Nm
invokes
.Ic oook- Ns Ar command ,
passing it
.Ar argument ...
as arguments.
The last argument to
.Ic oook- Ns Ar command
is the path to either the snapshot mount point or (if there is no
mount point) the snapshot volume.
To communicate to
.Ic oook- Ns Ar command
that a snapshot is being dumped,
.Nm
sets the variable
.Ev oook_snapshot_time
in its environment to the time when the snapshot was created,
formatted as a
.Ux
.Li time_t
value in decimal, possibly with a fractional part separated by
.Ql \&. .
.Sh ENVIRONMENT
.Bl -tag
.It Ev oook_snapshot_time
Passed to the child process, contains the time that the snapshot was
created.
.El
.Sh EXAMPLES
Suppose that there's a volume group
.Ql main
containing a logical volume
.Ql home
mounted on
.Pa /home .
Running this:
.Pp
.Dl oook-with-lvm2-snapshot dump-xfs incr /home
.Pp
will create a new snapshot logical volume
.Ql oooksnap_home ,
mount it read-only at
.Pa /.oooksnap/home ,
and run:
.Pp
.Dl oook-dump-xfs incr /.oooksnap/home
.Pp
with
.Ev oook_snapshot_time
set to (for instance)
.Ql 1497447433.65 .
.Pp
.Nm
is usually invoked by
.Xr oook-client 1 .
For instance, if
.Pa /home
is an XFS filesystem mounted from a logical volume, a suitable line in
.Pa /etc/oook/fslist
would be:
.Pp
.Dl /home with-lvm2-snapshot dump-xfs
.Sh FILES
.Bl -tag
.It Pa /.oooksnap
Directory below which snapshots are mounted.
.El
.Sh SEE ALSO
.Xr oook-client 1 ,
.Xr lvcreate 8 .
.Sh AUTHORS
.Nm
and this manual page were written by Ben Harris for the University of
Cambridge Information Services.
